controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\SqlDataProvider;
use yii\data\ActiveDataProvider;
use app\models\Parques;
use app\models\Dirigentes;
use app\models\Establecimientos;
class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
    public function actionConsulta1(){
        $numero = Yii::$app->db
                ->createCommand("select count(distinct lugar) from parques")
                ->queryScalar();
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT DISTINCT lugar FROM parques",
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['lugar'],
            "titulo"=>"Consulta 1 con DAO",
            "enunciado"=>"Listar los lugares de los parques (sin repetidos)",
            "sql"=>"SELECT DISTINCT lugar FROM parques",
        ]);
    }
    
    
     public function actionConsulta2(){
        $numero = Yii::$app->db
                ->createCommand("select count(distinct nombre) as contarnombre from dirigentes")
                ->queryScalar();
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT COUNT(DISTINCT nombre) AS contarnombre FROM dirigentes",
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['contarnombre'],
            "titulo"=>"Consulta 2 con DAO",
            "enunciado"=>"Número de dirigentes que hay",
            "sql"=>"SELECT COUNT(DISTINCT nombre) AS contarnombre FROM dirigentes",
        ]);
    }
    
    public function actionConsulta3(){
        $numero = Yii::$app->db
                ->createCommand("select avg(numero_empleados) as mediaempleados from parques")
                ->queryScalar();
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT AVG(numero_empleados) AS mediaempleados FROM parques",
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['mediaempleados'],
            "titulo"=>"Consulta 3 con DAO",
            "enunciado"=>"Media de empleados que hay por parque",
            "sql"=>"SELECT AVG(numero_empleados) AS mediaempleados FROM parques",
        ]);
    }
    
    public function actionConsulta4(){
       
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT nombre,MAX(numero_empleados) as maximoempleados FROM parques",
           
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['nombre','maximoempleados'],
            "titulo"=>"Consulta 4 con DAO",
            "enunciado"=>"El parque con más empleados",
            "sql"=>"SELECT nombre,MAX(numero_empleados) as maximoempleados FROM parques",
        ]);
    }
    
     public function actionConsulta5(){
        $numero = Yii::$app->db
                ->createCommand("select codigo,nombre from empleados group by codigo")
                ->queryScalar();
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT codigo,nombre FROM empleados GROUP BY codigo",
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['codigo','nombre'],
            "titulo"=>"Consulta 5 con DAO",
            "enunciado"=>"Mostrar el codigo y el nombre de los empleados",
            "sql"=>"SELECT codigo,nombre FROM empleados GROUP BY codigo",
        ]);
    }
    
    public function actionConsulta6(){
        $numero = Yii::$app->db
                ->createCommand("select codigo_establecimiento,nombre,apellido from empleados group by codigo_establecimiento having nombre like 'P%'")
                ->queryScalar();
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT  codigo_establecimiento,nombre,apellido FROM empleados GROUP BY codigo_establecimiento HAVING nombre LIKE 'P%'",
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['codigo_establecimiento','nombre','apellido'],
            "titulo"=>"Consulta 6 con DAO",
            "enunciado"=>"Mostrar aquellos empleados que trabajen en establecimientos que empiecen por P",
            "sql"=>"SELECT  codigo_establecimiento,nombre,apellido FROM empleados GROUP BY codigo_establecimiento HAVING nombre LIKE 'P%'",
        ]);
    }
    
    public function actionConsulta7(){
        $numero = Yii::$app->db
                ->createCommand("select codigo,nombre,codigo_parque from establecimientos group by codigo having char_length(nombre)>10")
                ->queryScalar();
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT codigo,nombre,codigo_parque FROM establecimientos GROUP BY codigo HAVING CHAR_LENGTH(nombre)>10",
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['codigo','nombre','codigo_parque'],
            "titulo"=>"Consulta 7 con DAO",
            "enunciado"=>"Mostrar los establecimientos de los parques cuyo nombre sea mayor de 10 caracteres",
            "sql"=>"SELECT  codigo,nombre,codigo_parque FROM establecimientos GROUP BY codigo HAVING CHAR_LENGTH(nombre)>10",
        ]);
    }
    
    public function actionConsulta8(){
        
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT DISTINCT empleados.nombre FROM empleados INNER JOIN atracciones a ON empleados.codigo_atraccion = a.codigo WHERE a.nombre='Dragon Khan'",
            
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['nombre'],
            "titulo"=>"Consulta 8 con DAO",
            "enunciado"=>"Mostrar los empleados que trabajen en un parque cuya atracción principal sea el Dragon Khan",
            "sql"=>"SELECT DISTINCT empleados.nombre FROM empleados INNER JOIN atracciones a ON empleados.codigo_atraccion = a.codigo WHERE a.nombre='Dragon Khan'",
        ]);
    }
    
    
    public function actionConsulta9(){
        
        $dataprovider=new SqlDataProvider([
            'sql'=>"SELECT DISTINCT parques.nombre FROM parques INNER JOIN pertenece p ON parques.codigo = p.codigo_parque INNER JOIN empresas e ON p.cif = e.cif WHERE e.nombre='DISNEY'",
            
            'pagination'=>[
                'pageSize' => 5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataprovider,
            "campos"=>['nombre'],

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'Consultas de los parques de atracciones';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de los parques</h1>
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 1</h3>
                        <p>Listar los lugares de los parques (sin repetidos)</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta1'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
            <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 2</h3>
                        <p>Número de dirigentes que hay</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta2'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
            <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 3</h3>
                        <p>Media de empleados que hay por parque</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta3'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 4</h3>
                        <p>El parque con más empleados</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta4'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
              <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 5</h3>
                        <p>Mostrar el codigo y el nombre de los empleados</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta5'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                  
                  <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 6</h3>
                        <p>Mostrar aquellos empleados que trabajen en establecimientos que empiecen por P</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta6'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                      
                      <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 7</h3>
                        <p>Mostrar los establecimientos de los parques cuyo nombre sea mayor de 10 caracteres</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta7'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>
                          
                         <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 8</h3>
                        <p>Mostrar los empleados que trabajen en un parque cuya atracción principal sea el Dragon Khan</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta8'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>   
                             
                           <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 9</h3>
                        <p>Mostrar los parques que pertenezcan a la empresa DISNEY</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta9'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div>                
                
                      <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class ="caption">
                        <h3>Consulta 10</h3>
                        <p>Mostrar el parque dirige Mark Smith</p>
                        <p>
                            <?= Html::a('DAO', ['site/consulta10'], ['class' => 'btn btn-default'])?>
                        </p>
                    </div>
                </div>  
            </div> 
                   
                   
                        
        </div>
    </div>
</div>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"col-lg-offset-1 col-lg-3\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="col-lg-offset-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>
<div class="jumbotron">
    <h2><?=$titulo?></h2>
    
    <p class="lead"><?=$enunciado?></p>
    <div class="well">
     <?= $sql ?>
    </div>    
   </div>

<?=GridView::widget([
    'dataProvider' => $resultados,
    'columns' =>$campos
]); ?>